	include	"doorsos.h"
	include	"graphlib.h"
        xdef    _ti89
        xdef    _comment
        xdef    _main

_main:
        move.w  #$0700,d0
        trap    #1
        movem.l d0-d7/a0-a6,-(a7)

test_1ere_fois:
        bsr     clr_scr2
        lea     kc1(pc),a1
        lea     keycode(pc),a0
        bsr     comp
        cmp.b   #1,d3
        bne     start_prgm

        move.w  #2,d0
        bsr     set_font

        move.w  #0,-(a7)        ;color #4 : black on whithe
        pea     titre(pc)       ;adress of the string
        move.w  #1,-(a7)        ;y coord
        move.w  #42,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7       ;restores the stack

        lea     LCD_MEM+44,a1
        move.w  #9,d0
loop_cadre_t1:
        or.b    #$20,(a1)
        adda.l  #30,a1
        dbra.w  d0,loop_cadre_t1

        lea     LCD_MEM+5,a1
        move.b  #$3F,(a1)+
        move.l  #$FFFFFFFF,(a1)+
        move.l  #$FFFFFFFF,(a1)+
        move.b  #$E0,(a1)+

        move.w  #0,d0
        bsr     set_font

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     misenp(pc)       ;adress of the string
        move.w  #12,-(a7)        ;y coord
        move.w  #55,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     first1(pc)       ;adress of the string
        move.w  #20,-(a7)        ;y coord
        move.w  #34,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7       ;restores the stack

        bsr     ch_t_j1

        move.w  #0,d0
        bsr     set_font

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     first2(pc)       ;adress of the string
        move.w  #28,-(a7)        ;y coord
        move.w  #34,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7       ;restores the stack

        bsr     ch_t_j2


start_prgm:
        bsr     clr_scr2

;**************************
;* Mise en place du titre *
;**************************
        move.w  #2,d0
        bsr     set_font

        move.w  #0,-(a7)        ;color #4 : black on whithe
        pea     titre(pc)       ;adress of the string
        move.w  #1,-(a7)        ;y coord
        move.w  #42,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7       ;restores the stack

        lea     LCD_MEM+44,a1
        move.w  #9,d0
loop_cadre_t:
        or.b    #$20,(a1)
        adda.l  #30,a1
        dbra.w  d0,loop_cadre_t

        lea     LCD_MEM+5,a1
        move.b  #$3F,(a1)+
        move.l  #$FFFFFFFF,(a1)+
        move.l  #$FFFFFFFF,(a1)+
        move.b  #$E0,(a1)+

        move.w  #1,d0
        bsr     set_font

;**************************
;* Mise en place du cadre *
;**************************
        lea     LCD_MEM+30*64+5,a0
        move.b  #$01,(a0)+
        move.l  #$FFFFFFFF,(a0)+
        move.l  #$FFFFFFFC,(a0)+
        lea     LCD_MEM+30*33+5,a0
        move.b  #$01,(a0)+
        move.l  #$FFFFFFFF,(a0)+
        move.l  #$FFFFFFFC,(a0)+
        lea     LCD_MEM+30*34+5,a0
        lea     LCD_MEM+30*34+13,a1
        move.w  #29,d0
loop_cadre:
        move.b  #$01,(a0)
        move.b  #$04,(a1)
        adda.l  #30,a0
        adda.l  #30,a1
        dbra.w  d0,loop_cadre

;****************************
;* Mise en place des textes *
;****************************
        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     start(pc)       ;adress of the string
        move.w  #35,-(a7)        ;y coord
        move.w  #64,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     quit(pc)       ;adress of the string
        move.w  #55,-(a7)        ;y coord
        move.w  #57,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     defkey(pc)       ;adress of the string
        move.w  #45,-(a7)        ;y coord
        move.w  #57,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.w  #0,d0
        bsr     set_font

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     misenp(pc)       ;adress of the string
        move.w  #12,-(a7)        ;y coord
        move.w  #55,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack
        
        move.l  #0,d5
        bsr     surl_ch

demarrage:
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,1(a0)
        beq     demarrage
        btst.b  #0,6(a0)
        beq     demarrage

;***********************
;* Dfilement du texte *
;***********************
        move.w  #2,d0
        bsr     set_font
recommence:
        lea     txt(pc),a1
main_loop:
        move.w  #7,d7
loop2:
        move.w  #30*10,d2
        lea     LCD_MEM,a0
        adda.l  #30*94-1,a0
loop:
        clr.w   d0
        move.b  (a0),d0
        lsl.w   #1,d0
        cmp.b   #1,d1
        bne     l3suite2
        add.b   #1,d0
        clr.b   d1
l3suite2:
        move.b  d0,(a0)
        cmp.w   #$100,d0
        blt     l3suite1
        move.b  #1,d1
l3suite1:
        suba.l  #1,a0
        dbra.w  d2,loop
        move.w  #$6000,d2
l2pause:
        dbra.w  d2,l2pause
        btst.b  #1,d7
        beq     fin_tst_intro
        btst.b  #0,d7
        beq     fin_tst_intro
        bsr     getkeystat
        lea     keystat(pc),a2
        btst.b  #0,6(a2)
        beq     fin
        btst.b  #0,1(a2)
        bne     tstu
        cmp.l   #0,d5
        beq     newgame
        cmp.l   #2,d5
        beq     fin
        cmp.l   #1,d5
        bne     tstu
        bsr     options
        bra     start_prgm

tstu:
        btst.b  #0,(a2)
        bne     tstd
        cmp.l   #0,d5
        beq     fin_tst_intro
        bsr     surl_ch
        sub.l   #1,d5
        bsr     surl_ch
        bra     fin_tst_intro
tstd:
        btst.b  #2,(a2)
        bne     fin_tst_intro
        cmp.l   #2,d5
        beq     fin_tst_intro
        bsr     surl_ch
        add.l   #1,d5
        bsr     surl_ch

fin_tst_intro:
        dbra.w  d7,loop2

eff:
        lea     LCD_MEM,a0
        lea     2540(a0),a0
        move.w  #9,d7
        clr.b   d1
loop_eff:
        move.b  d1,(a0)+
        move.b  d1,(a0)
        lea     29(a0),a0
        dbra.w  d7,loop_eff


        tst.b   (a1)
        beq     fini
        lea     char(pc),a0
        move.b  (a1)+,(a0)
	movem.l	a1,-(a7)
        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     char(pc)       ;adress of the string
        move.w  #84,-(a7)        ;y coord
        move.w  #160,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7
	movem.l	(a7)+,a1

        bra     main_loop
fini:
        bra     recommence


newgame:
        move.w  #1,d0
        bsr     set_font

        lea     pt_p1(pc),a0
        move.b  #0,(a0)+
        move.b  #0,(a0)+
        
new:
        bsr     clr_scr1
        bsr     aff_pt_p1
        bsr     aff_pt_p2
        lea     tab(pc),a1
        move.w  #10,d1
boucle_0:        
        move.w  #18,d2
boucle_1:                               
        btst.w  #0,d2
        beq     choose_brick
        btst.w  #0,d1
        beq     choose_brick
        move.b  #2,(a1)+
        bne     fin_boucle_1
choose_brick:        
        move.w  #8,d0                  
        bsr     random
        cmp.w   #7,d0
        blt     brick
        move.b  #0,(a1)+
        bra     fin_boucle_1
brick:        
        move.b  #1,(a1)+                
fin_boucle_1:
        dblt    d2,boucle_1
        dblt    d1,boucle_0
        lea     tab(pc),a1
        move.b  #0,(a1)+
        move.b  #0,(a1)+
        lea     17(a1),a1
        move.b  #0,(a1)
        lea     170(a1),a1
        move.b  #0,(a1)
        lea     18(a1),a1
        move.b  #0,(a1)+
        move.b  #0,(a1)+


;******************************
;* Affichage du contenu de a1 *       
;******************************        
        lea     tab(pc),a1
        lea     209(a1),a1
        move.b  #$FF,d3
        move.w  #10,d5
boucle_2:
        move.w  #18,d6
boucle_3:
        move.w  d6,d0
        lsl.w   #3,d0
        move.w  d5,d1
        lsl.w   #3,d1
        move.b  -(a1),d4
        cmp.b   #1,d4
        bne     no_brick
        lea     brique(pc),a0
        bra     aff
no_brick:
        cmp.b   #2,d4
        bne     fin_boucle_3
        lea     mur(pc),a0
aff:
        jsr     graphlib::put_sprite_mask
fin_boucle_3:
        dbra    d6,boucle_3                     ;Le tableau est affich 
        dbra    d5,boucle_2                     ;l'envers!
;**************
;* Reset Data *
;**************
        lea     force_p2(pc),a0
        move.l  #0,(a0)
        lea     force_p1(pc),a0
        move.l  #0,(a0)
        lea     xy_p2(pc),a0
        move.l  #18,(a0)+
        move.l  #10,(a0)
        lea     btab_p1(pc),a0
        lea     btab_p2(pc),a1
        move.w  #17,d0
loop_res_1:
        move.l  #0,(a0)+
        move.l  #0,(a1)+
        dbra.w  d0,loop_res_1
        lea     nb_p1(pc),a0
        move.w  #1,(a0)
        lea     just_b_p1(pc),a0
        move.l  #0,(a0)
        lea     nb_p2(pc),a0
        move.w  #1,(a0)
        lea     xy_p1(pc),a0
        clr.l   (a0)+
        clr.l   (a0)
        bsr     aff_player1
        bsr     aff_player2
get_key:        
pause:
        lea     speed(pc),a0
        clr.w   d0
        move.b  (a0),d0
        not.w   d0
        add.w   #19,d0
pause_1:
        move.l  #$DFF,d1
pause_2:        
        sub.l   #1,d1
        cmp.l   #0,d1
        bne     pause_2
        dbra.w  d0,pause_1
        bsr     tst_death_p1
        cmp.b   #1,d0
        beq     death_p1
        bsr     tst_death_p2
        cmp.b   #1,d0
        beq     death_p2
        lea     btab_p1(pc),a3
        move.b  #6,d6
l_tst_b_p1:
        lea     bombe_p1(pc),a0
        move.l  (a3)+,(a0)+
        move.l  (a3)+,(a0)+
        move.l  (a3)+,(a0)+
        sub.l   #12,a3
        bsr     tst_bombe_p1
        cmp.b   #1,d0
        beq     death_p1
        lea     bombe_p1(pc),a0
        move.l  (a0)+,(a3)+
        move.l  (a0)+,(a3)+
        move.l  (a0)+,(a3)+
        sub.b   #1,d6
        cmp.b   #0,d6
        bne     l_tst_b_p1
        move.b  #6,d6
        lea     btab_p2(pc),a3
l_tst_b_p2:
        lea     bombe_p2(pc),a0
        move.l  (a3)+,(a0)+
        move.l  (a3)+,(a0)+
        move.l  (a3)+,(a0)+
        sub.l   #12,a3
        bsr     tst_bombe_p2
        cmp.b   #1,d0
        beq     death_p2
        lea     bombe_p2(pc),a0
        move.l  (a0)+,(a3)+
        move.l  (a0)+,(a3)+
        move.l  (a0)+,(a3)+
        sub.b   #1,d6
        cmp.b   #0,d6
        bne     l_tst_b_p2
        bsr     tst_death_p1
        cmp.b   #1,d0
        beq     death_p1
        bsr     tst_death_p2
        cmp.b   #1,d0
        beq     death_p2
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,6(a0)
        beq     start_prgm
        lea     kc2(pc),a1
        bsr     comp2
        cmp.b   #1,d3
        beq     pose_bombe_2
        bsr     comp2
        cmp.b   #1,d3
        beq     move_up_2
        bsr     comp2
        cmp.b   #1,d3
        beq     move_down_2
        bsr     comp2
        cmp.b   #1,d3
        beq     move_left_2
        bsr     comp2
        cmp.b   #1,d3
        beq     move_right_2
;        btst.b  #5,1(a0)
;        beq     pose_bombe_2
;        btst.b  #3,(a0)
;        beq     move_right_2
;        btst.b  #2,(a0)
;        beq     move_down_2
;        btst.b  #0,(a0)
;        beq     move_up_2
;        btst.b  #1,(a0)
;        beq     move_left_2
tst_key_p1:
        lea     keystat(pc),a0
        lea     kc1(pc),a1
        bsr     comp2
        cmp.b   #1,d3
        beq     pose_bombe_1
        bsr     comp2
        cmp.b   #1,d3
        beq     move_up_1
        bsr     comp2
        cmp.b   #1,d3
        beq     move_down_1
        bsr     comp2
        cmp.b   #1,d3
        beq     move_left_1
        bsr     comp2
        cmp.b   #1,d3
        beq     move_right_1
;        btst.b  #0,2(a0)
;        beq     pose_bombe_1
;        btst.b  #3,5(a0)
;        beq     move_up_1
;        btst.b  #1,5(a0)
;        beq     move_down_1
;        btst.b  #0,4(a0)
;        beq     move_left_1
;        btst.b  #0,3(a0)
;        beq     move_right_1
        bra     get_key

pose_bombe_1:
        lea     just_b_p1(pc),a0
        cmp.w   #0,(a0)
        bne     get_key
        lea     nb_p1(pc),a0
        move.w  (a0),d0
        lea     btab_p1(pc),a2
        cmp.w   #6,d0
        blt     deb_tst_bp1
        move.w  #6,d0
deb_tst_bp1:
        cmp.w   #0,(a2)
        beq     suite_bp1
        adda.l  #12,a2
        sub.w   #1,d0
        cmp.w   #0,d0
        bne     deb_tst_bp1
        bra     get_key
suite_bp1:
        lea     bombe_p1(pc),a0
        move.w  #1,(a0)+                        ;Le joueur a pos une bombe
        move.w  #1,(a0)+                        ;La bombe vient d'tre pose
        move.w  #11,(a0)
        bsr     aff_bombe1
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1),d1
        move.w  d0,(a0)+
        move.w  d1,(a0)
        bsr     get_tab_d0_d1_in_d5
        add.b   #5,d5
        bsr     put_d5_in_tab_d0_d1
        lea     bombe_p1(pc),a0
        move.l  (a0)+,(a2)+
        move.l  (a0)+,(a2)+
        move.l  (a0),(a2)
        lea     just_b_p1(pc),a0
        move.w  #1,(a0)
        bra     get_key
pose_bombe_2:
        lea     just_b_p2(pc),a0
        cmp.w   #0,(a0)
        bne     tst_key_p1
        lea     nb_p2(pc),a0
        move.w  (a0),d0
        lea     btab_p2(pc),a2
        cmp.w   #6,d0
        blt     deb_tst_bp2
        move.w  #6,d0
deb_tst_bp2:
        cmp.w   #0,(a2)
        beq     suite_bp2
        adda.l  #12,a2
        sub.w   #1,d0
        cmp.w   #0,d0
        bne     deb_tst_bp2
        bra     tst_key_p1
suite_bp2:
        lea     bombe_p2(pc),a0
        move.w  #1,(a0)+                        ;Le joueur a pos une bombe
        move.w  #1,(a0)+                        ;La bombe vient d'tre pose
        move.w  #11,(a0)
        bsr     aff_bombe2
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1),d1
        move.w  d0,(a0)+
        move.w  d1,(a0)
        bsr     get_tab_d0_d1_in_d5
        add.b   #5,d5
        bsr     put_d5_in_tab_d0_d1
        lea     bombe_p2(pc),a0
        move.l  (a0)+,(a2)+
        move.l  (a0)+,(a2)+
        move.l  (a0),(a2)
        lea     just_b_p2(pc),a0
        move.w  #1,(a0)
        bra     tst_key_p1
move_left_2:
        bsr     test_blanc2
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #0,d0
        beq     after_move_2    
        sub.l   #1,d0
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p2
        cmp.b   #3,d5
        bne     suite5
        lea     force_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite5:
        cmp.b   #4,d5
        bne     suite13
        lea     nb_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite13:
        cmp.b   #8,d5
        bge     enr_l_p2
        cmp.b   #0,d5
        bne     after_move_2
enr_l_p2:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_2
move_up_2:
        bsr     test_blanc2
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #0,d1
        beq     after_move_2    
        sub.l   #1,d1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p2
        cmp.b   #3,d5
        bne     suite6
        lea     force_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite6:
        cmp.b   #4,d5
        bne     suite14
        lea     nb_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite14:
        cmp.b   #8,d5
        bge     enr_u_p2
        cmp.b   #0,d5
        bne     after_move_2
enr_u_p2:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_2
move_down_2:
        bsr     test_blanc2
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #10,d1
        beq     after_move_2    
        add.l   #1,d1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p2
        cmp.b   #3,d5
        bne     suite7
        lea     force_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite7:
        cmp.b   #4,d5
        bne     suite15
        lea     nb_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite15:
        cmp.b   #8,d5
        bge     enr_d_p2
        cmp.b   #0,d5
        bne     after_move_2
enr_d_p2:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_2
move_right_2:
        bsr     test_blanc2
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #18,d0
        beq     after_move_2
        add.l   #1,d0
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p2
        cmp.b   #3,d5
        bne     suite8
        lea     force_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite8:
        cmp.b   #4,d5
        bne     suite16
        lea     nb_p2(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite16:
        cmp.b   #8,d5
        bge     enr_r_p2
        cmp.b   #0,d5
        bne     after_move_2
enr_r_p2:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_2
after_move_2:
        bsr     aff_player2
        bra     tst_key_p1
move_left_1:
        bsr     test_blanc1
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #0,d0
        beq     after_move_1    
        sub.l   #1,d0
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p1
        cmp.b   #3,d5
        bne     suite1
        lea     force_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite1:
        cmp.b   #4,d5
        bne     suite9
        lea     nb_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite9:
        cmp.b   #8,d5
        bge     enr_l_p1
        cmp.b   #0,d5
        bne     after_move_1
enr_l_p1:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_1
move_up_1:
        bsr     test_blanc1
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #0,d1
        beq     after_move_1    
        sub.l   #1,d1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p1
        cmp.b   #3,d5
        bne     suite2
        lea     force_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite2:
        cmp.b   #4,d5
        bne     suite10
        lea     nb_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite10:
        cmp.b   #8,d5
        bge     enr_u_p1
        cmp.b   #0,d5
        bne     after_move_1
enr_u_p1:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_1
move_down_1:
        bsr     test_blanc1
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #10,d1
        beq     after_move_1    
        add.l   #1,d1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p1
        cmp.b   #3,d5
        bne     suite3
        lea     force_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite3:
        cmp.b   #4,d5
        bne     suite11
        lea     nb_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite11:
        cmp.b   #8,d5
        bge     enr_d_p1
        cmp.b   #0,d5
        bne     after_move_1
enr_d_p1:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_1
move_right_1:
        bsr     test_blanc1
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1)+,d1
        cmp.l   #18,d0
        beq     after_move_1    
        add.l   #1,d0
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #8,d5
        bge     death_p1
        cmp.b   #3,d5
        bne     suite4
        lea     force_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite4:
        cmp.b   #4,d5
        bne     suite12
        lea     nb_p1(pc),a2
        add.w   #1,(a2)
        move.b  #0,d5
        bsr     put_d5_in_tab_d0_d1
suite12:
        cmp.b   #8,d5
        bge     enr_r_p1
        cmp.b   #0,d5
        bne     after_move_1
enr_r_p1:
        move.l  d1,-(a1)
        move.l  d0,-(a1)
        bra     after_move_1
after_move_1:
        bsr     aff_player1
        bra     get_key
fin:        
        bsr     clr_scr2
demarrage_fin:
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,1(a0)
        beq     demarrage_fin

        movem.l (a7)+,d0-d7/a0-a6
        move.w  #$0700,d0
        trap    #1
        rts

tst_death_p2:
        lea     xy_p2(pc),a0
        move.l  (a0)+,d0
        move.l  (a0),d1
        bsr     get_tab_d0_d1_in_d5
        clr.b   d0
        lea     just_b_p2(pc),a0
        cmp.w   #1,(a0)
        beq     no_death_p2
        cmp.b   #8,d5
        blt     no_death_p2
        move.b  #1,d0
no_death_p2:
        rts

death_p2:
        move.w  #0,-(a7)        ;color #4 : black on whithe
        pea     dp2(pc)       ;adress of the string
        move.w  #41,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        lea     pt_p1(pc),a0
        add.b   #1,(a0)
        bsr     aff_pt_p1
pause_dp2:
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,1(a0)
        beq     new
        btst.b  #0,6(a0)
        beq     fin
        bra     pause_dp2

tst_death_p1:
        lea     xy_p1(pc),a0
        move.l  (a0)+,d0
        move.l  (a0),d1
        bsr     get_tab_d0_d1_in_d5
        clr.b   d0
        lea     just_b_p1(pc),a0
        cmp.w   #1,(a0)
        beq     no_death_p1
        cmp.b   #8,d5
        blt     no_death_p1
        move.b  #1,d0
no_death_p1:
        rts


death_p1:       
        move.w  #0,-(a7)        ;color #4 : black on whithe
        pea     dp1(pc)       ;adress of the string
        move.w  #41,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        lea     pt_p2(pc),a0
        add.b   #1,(a0)
        bsr     aff_pt_p2

pause_dp1:        
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,1(a0)
        beq     new
        btst.b  #0,6(a0)
        beq     fin
        bra     pause_dp1

;*******************************
;* Test bombe pour le player 1 *
;*******************************

tst_bombe_p1:
        lea     bombe_p1(pc),a0
        cmp.w   #1,(a0)                 ;y a-t-il une bombe
        bne     fin_tst_bombe_p1
        cmp.w   #0,10(a0)
        bne     bombe_fin_expl1             ;la bombe est-elle en train d'exploser
        sub.w   #1,4(a0)        
        cmp.w   #0,4(a0)                ;le compteur est-il  zro
        bne     fin_tst_bombe_p1        
        lea     bombe_p1(pc),a0
        clr.l   d0-d1
        move.w  #2,10(a0)               ;la bombe explose
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        bsr     aff_expl
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
right_b1:        
        lea     force_p1(pc),a2
        move    (a2),d7
loop_right_b1:
        add.w   #1,d0
        cmp.w   #19,d0
        beq     left_b1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     left_b1
        cmp.b   #1,d5
        beq     b_r_b1
        cmp.b   #5,d5
        beq     brique_right_b1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_right_b1
        bra     left_b1
brique_right_b1:
        move.b  #13,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_right_b1
        bra     left_b1
b_r_b1:
        bsr     expl_br_in_d5
        bset.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
left_b1:        
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_left_b1:
        sub.w   #1,d0
        cmp.b   #$FF,d0
        beq     down_b1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     down_b1
        cmp.b   #1,d5
        beq     b_l_b1
        cmp.b   #5,d5
        beq     brique_left_b1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_left_b1
        bra     down_b1
brique_left_b1:
        move.b  #13,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_left_b1
        bra     down_b1
b_l_b1:
        bsr     expl_br_in_d5
        bset.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
down_b1:        
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_down_b1:
        add.w   #1,d1
        cmp.w   #11,d1
        beq     up_b1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     up_b1
        cmp.b   #1,d5
        beq     b_d_b1
        cmp.b   #5,d5
        beq     brique_down_b1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_down_b1
        bra     up_b1
brique_down_b1:
        move.b  #13,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_down_b1
        bra     up_b1
b_d_b1:
        bsr     expl_br_in_d5
        bset.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
up_b1:        
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_up_b1:
        sub.w   #1,d1
        cmp.b   #$FF,d1
        beq     test_b_p1
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     test_b_p1
        cmp.b   #1,d5
        beq     b_u_b1
        cmp.b   #5,d5
        beq     brique_up_b1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_up_b1
        bra     test_b_p1

brique_up_b1:
        move.b  #13,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_up_b1
        bra     test_b_p1
b_u_b1:
        bsr     expl_br_in_d5
        bset.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        bra     test_b_p1

test_b_p1:
        lea     bombe_p1(pc),a0
        lea     xy_p1(pc),a1
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.l  (a1)+,d1
        cmp.w   d0,d1
        bne     passe_p1
        move.w  (a0)+,d0
        move.l  (a1)+,d1
        cmp.w   d0,d1
        bne     passe_p1
        move.b  #1,d0
        rts
        
passe_p1:
        bra     fin_tst_bombe_p1


bombe_fin_expl1:        
        cmp.w   #1,10(a0)
        bne     timer_b1
        sub.w   #1,10(a0)       ;la bombe a fini d'exploser  
        clr.l   d0-d1
        move.w  #0,(a0)
        clr.b   d5
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        bsr     put_d5_in_tab_d0_d1
        bsr     clr_expl
right_f_b1:
loop_right_f_b1:
        add.w   #1,d0
        cmp.w   #19,d0
        beq     left_f_b1
        bsr     get_tab_d0_d1_in_d5
        btst.b  #3,d5
        beq     left_f_b1
        bclr.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl1
        bsr     aff_pp
        bra     loop_right_f_b1
clr_expl1:
        cmp.b   #4,d5
        bne     clr_expl9
        bsr     aff_bplus
        bra     loop_right_f_b1
clr_expl9:
        cmp.b   #5,d5
        bne     clr_expl17
        bsr     aff_bombe
        bra     loop_right_f_b1
clr_expl17:
        bsr     clr_expl
        bra     loop_right_f_b1
left_f_b1:
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_left_f_b1:
        sub.w   #1,d0
        cmp.b   #$FF,d0   
        beq     down_f_b1
        bsr     get_tab_d0_d1_in_d5
        btst.b  #3,d5
        beq     down_f_b1
        bclr.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl2
        bsr     aff_pp
        bra     loop_left_f_b1
clr_expl2:
        cmp.b   #4,d5
        bne     clr_expl10
        bsr     aff_bplus
        bra     loop_left_f_b1
clr_expl10:
        cmp.b   #5,d5
        bne     clr_expl18
        bsr     aff_bombe
        bra     loop_left_f_b1
clr_expl18:
        bsr     clr_expl
        bra     loop_left_f_b1
down_f_b1:
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_down_f_b1:
        add.w   #1,d1
        cmp.w   #11,d1
        beq     up_f_b1
        bsr     get_tab_d0_d1_in_d5
        btst.b  #3,d5
        beq     up_f_b1
        bclr.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl3
        bsr     aff_pp
        bra     loop_down_f_b1
clr_expl3:
        cmp.b   #4,d5
        bne     clr_expl11
        bsr     aff_bplus
        bra     loop_down_f_b1
clr_expl11:
        cmp.b   #5,d5
        bne     clr_expl19
        bsr     aff_bombe
        bra     loop_down_f_b1
clr_expl19:
        bsr     clr_expl
        bra     loop_down_f_b1
up_f_b1:
        lea     bombe_p1(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_up_f_b1:
        sub.w   #1,d1
        cmp.b   #$FF,d1
        beq     fin_expl_p1
        bsr     get_tab_d0_d1_in_d5
        btst.b  #3,d5
        beq     fin_expl_p1
        bclr.b  #3,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl4
        bsr     aff_bplus
        bra     loop_up_f_b1
clr_expl4:
        cmp.b   #4,d5
        bne     clr_expl12
        bsr     aff_pp
        bra     loop_up_f_b1
clr_expl12:
        cmp.b   #5,d5
        bne     clr_expl20
        bsr     aff_bombe
        bra     loop_up_f_b1
clr_expl20:
        bsr     clr_expl
        bra     loop_up_f_b1
fin_expl_p1:
        lea     btab_p1(pc),a0
        move.l  a0,a1
        adda.l  #12,a0
        move.w  #14,d0
loop_m_btab_p1:
        move.l  (a0)+,(a1)+
        dbra.w  d0,loop_m_btab_p1
        clr.l   (a1)+
        clr.l   (a1)+
        clr.l   (a1)+
        sub.w   #1,d6
        suba.l  #12,a3
        bra     fin_tst_bombe_p1

timer_b1:
        sub.w   #1,10(a0)       ;la bombe est en train d'exploser

fin_tst_bombe_p1:
        clr.b   d0
        rts

;*******************************
;* Test bombe pour le player 2 *
;*******************************

tst_bombe_p2:
        lea     bombe_p2(pc),a0
        cmp.w   #1,(a0)                 ;y a-t-il une bombe
        bne     fin_tst_bombe_p2
        cmp.w   #0,10(a0)
        bne     bombe_fin_expl2             ;la bombe est-elle en train d'exploser
        sub.w   #1,4(a0)        
        cmp.w   #0,4(a0)                ;le compteur est-il  zro
        bne     fin_tst_bombe_p2        
        lea     bombe_p2(pc),a0
        clr.l   d0-d1
        move.w  #2,10(a0)               ;la bombe explose
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        bsr     aff_expl
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.b  #8,d5
        bsr     put_d5_in_tab_d0_d1
right_b2:        
        lea     force_p2(pc),a2
        move    (a2),d7
loop_right_b2:
        add.w   #1,d0
        cmp.w   #19,d0
        beq     left_b2
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     left_b2
        cmp.b   #1,d5
        beq     b_r_b2
        cmp.b   #5,d5
        beq     brique_right_b2
        move    #16,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_right_b2
        bra     left_b2
brique_right_b2:
        move.b  #21,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_right_b2
        bra     left_b2
b_r_b2:
        bsr     expl_br_in_d5
        bset.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
left_b2:        
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_left_b2:
        sub.w   #1,d0
        cmp.b   #$FF,d0
        beq     down_b2
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     down_b2
        cmp.b   #1,d5
        beq     b_l_b2
        cmp.b   #5,d5
        beq     brique_left_b2
        move    #16,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_left_b2
        bra     down_b2
brique_left_b2:
        move.b  #21,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_left_b2
        bra     down_b2
b_l_b2:
        bsr     expl_br_in_d5
        bset.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
down_b2:        
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_down_b2:
        add.w   #1,d1
        cmp.w   #11,d1
        beq     up_b2
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     up_b2
        cmp.b   #1,d5
        beq     b_d_b2
        cmp.b   #5,d5
        beq     brique_down_b2
        move    #16,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_down_b2
        bra     up_b2
brique_down_b2:
        move.b  #21,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_down_b2
        bra     up_b2
b_d_b2:
        bsr     expl_br_in_d5
        bset.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
up_b2:        
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move    (a2),d7
loop_up_b2:
        sub.w   #1,d1
        cmp.b   #$FF,d1
        beq     test_b_p2
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        beq     test_b_p2
        cmp.b   #1,d5
        beq     b_u_b2
        cmp.b   #5,d5
        beq     brique_up_b2
        move    #16,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        dblt    d7,loop_up_b2
        bra     test_b_p2

brique_up_b2:
        move.b  #21,d5
        bsr     put_d5_in_tab_d0_d1
        dblt    d7,loop_up_b2
        bra     test_b_p2

b_u_b2:
        bsr     expl_br_in_d5
        bset.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        bsr     aff_expl
        bra     test_b_p2

test_b_p2:
        lea     bombe_p2(pc),a0
        lea     xy_p2(pc),a1
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.l  (a1)+,d1
        cmp.w   d0,d1
        bne     passe_p2
        move.w  (a0)+,d0
        move.l  (a1)+,d1
        cmp.w   d0,d1
        bne     passe_p2
        move.b  #1,d0
        rts
passe_p2:
        bra     fin_tst_bombe_p2

bombe_fin_expl2:        
        cmp.w   #1,10(a0)
        bne     timer_b2
        sub.w   #1,10(a0)       ;la bombe a fini d'exploser  
        clr.l   d0-d1
        move.w  #0,(a0)
        clr.b   d5
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        bsr     put_d5_in_tab_d0_d1
        bsr     clr_expl
right_f_b2:
loop_right_f_b2:
        add.w   #1,d0
        cmp.w   #19,d0
        beq     left_f_b2
        bsr     get_tab_d0_d1_in_d5
        btst.b  #4,d5
        beq     left_f_b2
        bclr.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl5
        bsr     aff_pp
        bra     loop_right_f_b2
clr_expl5:
        cmp.b   #4,d5
        bne     clr_expl13
        bsr     aff_bplus
        bra     loop_right_f_b2
clr_expl13:
        cmp.b   #5,d5
        bne     clr_expl21
        bsr     aff_bombe
        bra     loop_right_f_b2
clr_expl21:
        bsr     clr_expl
        bra     loop_right_f_b2
left_f_b2:
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_left_f_b2:
        sub.w   #1,d0
        cmp.b   #$FF,d0   
        beq     down_f_b2
        bsr     get_tab_d0_d1_in_d5
        btst.b  #4,d5
        beq     down_f_b2
        bclr.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl6
        bsr     aff_pp
        bra     loop_left_f_b2
clr_expl6:
        cmp.b   #4,d5
        bne     clr_expl14
        bsr     aff_bplus
        bra     loop_left_f_b2
clr_expl14:
        cmp.b   #5,d5
        bne     clr_expl22
        bsr     aff_bombe
        bra     loop_left_f_b2
clr_expl22:
        bsr     clr_expl
        bra     loop_left_f_b2
down_f_b2:
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_down_f_b2:
        add.w   #1,d1
        cmp.w   #11,d1
        beq     up_f_b2
        bsr     get_tab_d0_d1_in_d5
        btst.b  #4,d5
        beq     up_f_b2
        bclr.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl7
        bsr     aff_pp
        bra     loop_down_f_b2
clr_expl7:
        cmp.b   #4,d5
        bne     clr_expl15
        bsr     aff_bplus
        bra     loop_down_f_b2
clr_expl15:
        cmp.b   #5,d5
        bne     clr_expl23
        bsr     aff_bombe
        bra     loop_down_f_b2
clr_expl23:
        bsr     clr_expl
        bra     loop_down_f_b2
up_f_b2:
        lea     bombe_p2(pc),a0
        adda.l  #6,a0
        move.w  (a0)+,d0
        move.w  (a0),d1
        move.w  #2,d7
loop_up_f_b2:
        sub.w   #1,d1
        cmp.b   #$FF,d1
        beq     fin_expl_p2
        bsr     get_tab_d0_d1_in_d5
        btst.b  #4,d5
        beq     fin_expl_p2
        bclr.b  #4,d5
        bsr     put_d5_in_tab_d0_d1
        cmp.b   #3,d5
        bne     clr_expl8
        bsr     aff_pp
        bra     loop_up_f_b2
clr_expl8:
        cmp.b   #4,d5
        bne     clr_expl16
        bsr     aff_bplus
        bra     loop_up_f_b2
clr_expl16:
        cmp.b   #5,d5
        bne     clr_expl24
        bsr     aff_bombe
        bra     loop_up_f_b2
clr_expl24:
        bsr     clr_expl
        bra     loop_up_f_b2
fin_expl_p2:
        lea     btab_p2(pc),a0
        move.l  a0,a1
        adda.l  #12,a0
        move.w  #14,d0
loop_m_btab_p2:
        move.l  (a0)+,(a1)+
        dbra.w  d0,loop_m_btab_p2
        clr.l   (a1)+
        clr.l   (a1)+
        clr.l   (a1)+
        sub.w   #1,d6
        suba.l  #12,a3
        bra     fin_tst_bombe_p2

timer_b2:
        sub.w   #1,10(a0)       ;la bombe est en train d'exploser

fin_tst_bombe_p2:
        clr.b   d0
        rts


get_tab_d0_d1_in_d5:                            ;Restaure d0 et d1
        movem.l d0-d1/a0,-(a7)
        muls    #19,d1
        add.l   d1,d0
        lea     tab(pc),a0
        adda.l  d0,a0
        move.b  (a0),d5
        movem.l (a7)+,d0-d1/a0
        rts

put_d5_in_tab_d0_d1:                            ;Ne restaure pas d0 et d1
        movem.l d0-d1/a0,-(a7)
        muls    #19,d1
        add.l   d0,d1
        lea     tab(pc),a0
        adda.l  d1,a0
        move.b  d5,(a0)
        movem.l (a7)+,d0-d1/a0
        rts

test_blanc2:
        lea     just_b_p2(pc),a0        
        move.w  (a0),d0
        cmp.w   #0,d0
        beq     blanc_test_oui2
        move.w  #0,(a0)
        rts
blanc_test_oui2:
        bsr     aff_blanc2
        rts

test_blanc1:
        lea     just_b_p1(pc),a0        
        move.w  (a0),d0
        cmp.w   #0,d0
        beq     blanc_test_oui
        move.w  #0,(a0)
        rts
blanc_test_oui:
        bsr     aff_blanc1
        rts

aff_p2:
        movem.l d0-d3/a1,-(a7)
        move.b  #$FF,d3
        lea     xy_p2(pc),a1
        move.l  (a1)+,d0
        move.l  (a1),d1
        lsl.w   #3,d0
        lsl.w   #3,d1
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a1
        rts

aff_p1:
        movem.l d0-d3/a1,-(a7)
        move.b  #$FF,d3
        lea     xy_p1(pc),a1
        move.l  (a1)+,d0
        move.l  (a1),d1
        lsl.w   #3,d0
        lsl.w   #3,d1
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a1
        rts

aff_bombe:       ;affiche  en (d0,d1)
        movem.l d0-d3/a0,-(a7)
        move.b  #$FF,d3
        lsl.w   #3,d0
        lsl.w   #3,d1
        lea     bombe(pc),a0
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a0
        rts

aff_bplus:       ;affiche  en (d0,d1)
        movem.l d0-d3/a0,-(a7)
        move.b  #$FF,d3
        lsl.w   #3,d0
        lsl.w   #3,d1
        lea     bplus(pc),a0
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a0
        rts

aff_pp:       ;affiche  en (d0,d1)
        movem.l d0-d3/a0,-(a7)
        move.b  #$FF,d3
        lsl.w   #3,d0
        lsl.w   #3,d1
        lea     pp(pc),a0
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a0
        rts

aff_expl:       ;affiche # en (d0,d1)
        movem.l d0-d3/a0,-(a7)
        move.b  #$FF,d3
        lsl.w   #3,d0
        lsl.w   #3,d1
        lea     exp(pc),a0
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a0
        rts

clr_expl:       ;affiche [ ] en (d0,d1)
        movem.l d0-d3/a0,-(a7)
        move.b  #$FF,d3
        lsl.w   #3,d0
        lsl.w   #3,d1
        lea     blanc(pc),a0
        jsr	  graphlib::put_sprite_mask
        movem.l (a7)+,d0-d3/a0
        rts

aff_bombe2:
        movem.l a0,-(a7)
        lea     bombe(pc),a0
        bsr     aff_p2
        movem.l a0,(a7)+
        rts
        
aff_blanc2:
        movem.l a0,-(a7)
        lea     blanc(pc),a0
        bsr     aff_p2
        movem.l (a7)+,a0
        rts

aff_player2:
        movem.l a0,-(a7)
        lea     p2(pc),a0
        bsr     aff_p2
        movem.l (a7)+,a0
        rts

aff_bombe1:
        movem.l a0,-(a7)
        lea     bombe(pc),a0
        bsr     aff_p1
        movem.l a0,(a7)+
        rts
        
aff_blanc1:
        movem.l a0,-(a7)
        lea     blanc(pc),a0
        bsr     aff_p1
        movem.l (a7)+,a0
        rts

aff_player1:
        movem.l a0,-(a7)
        lea     p1(pc),a0
        bsr     aff_p1
        movem.l (a7)+,a0
        rts

expl_br_in_d5:
        movem.l d0,-(a7)
        move.w  #4,d0
        bsr     random
        cmp.w   #1,d0
        bne     expl_br_1
        move.b  #3,d5
        bra     fin_expl_br
expl_br_1:
        cmp.w   #2,d0
        bne     expl_br_2
        move.b  #4,d5
        bra     fin_expl_br
expl_br_2:
        clr.b   d5
fin_expl_br:
        movem.l (a7)+,d0
        rts
    
aff_pt_p1:
        lea     LCD_MEM,a0
        adda.l  #30*11*8+30*3,a0
        lea     pt_p1(pc),a1
        clr.l   d0
        move.b  (a1),d0
        lsl.l   #3,d0
        lea     numbers(pc),a1
        adda.l  d0,a1
        move.w  #7,d0
loop_pt_p1:
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        dbra.w  d0,loop_pt_p1
        rts

aff_pt_p2:
        lea     LCD_MEM,a0
        adda.l  #30*11*8+30*3+18,a0
        lea     pt_p2(pc),a1
        clr.l   d0
        move.b  (a1),d0
        lsl.l   #3,d0
        lea     numbers(pc),a1
        adda.l  d0,a1
        move.w  #7,d0
loop_pt_p2:
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        dbra.w  d0,loop_pt_p2
        rts

clr_scr1:
        movem.l d0-d1/a0,-(a7)
        lea     LCD_MEM,a0
        move.w  #2999,d0
        clr.b   d1
loop_clr_scr1:
        move.b  d1,(a0)+
        dblt    d0,loop_clr_scr1
        lea     LCD_MEM,a0
        adda.l  #88*30,a0
        move.b  #$FF,d1
        move.w  #29,d0
loop_clr_scr2_1:
        move.b  d1,(a0)+
        dbra    d0,loop_clr_scr2_1
        movem.l (a7)+,d0-d1/a0
        rts

clr_scr2:
        movem.l d0-d1/a0,-(a7)
        lea     LCD_MEM,a0
        move.w  #2999,d0
        clr.b   d1
loop_clr_scr2:       
        move.b  d1,(a0)+
        dblt    d0,loop_clr_scr2
        movem.l (a7)+,d0-d1/a0
        rts

getkeystat:
  movem.l d0-d6/a6/a1,-(a7)
  lea keystat(pc),a6
  move.w #$FFFE,d0
  moveq #6,d1
gk_next:
  move.w  d0,$600018

  moveq #10,d6
gk_small_delay:
  dbra.w d6,gk_small_delay

  rol.w  #1,d0
  move.b  $60001B,(a6)+
  dbra d1,gk_next
  movem.l (a7)+,d0-d6/a6/a1
  rts


surl_ch:
        movem.l d2-d5/a0/a1,-(a7)
        lea     LCD_MEM+34*30+6,a0
        move.l  d5,d4
        lsl.l   #3,d4
        lsl.l   #1,d5
        add.l   d5,d4
        move.l  d4,d5
        lsl.l   #5,d4
        lsl.l   #1,d5
        sub.l   d5,d4
        adda.l  d4,a0
        move.w  #9,d3
l_surl1:
        move.w  #6,d2
l_surl2:
        not.b   (a0)+
        dbra.w  d2,l_surl2
        move.b  #$FC,d2
        move.b  (a0),d4
        sub.b   d4,d2
        bset.b  #2,d2
        move.b  d2,(a0)
        lea     23(a0),a0
        dbra.w  d3,l_surl1
        movem.l (a7)+,d2-d5/a0/a1
        rts
        

set_font:
        movem.l d0-d2,-(a7)
        move.w  d0,-(a7)
        jsr     doorsos::FontSetSys
        move.w  (a7)+,d0
        movem.l (a7)+,d0-d2
        rts


options:
        move.w  #1,d0
        bsr     set_font

        bsr     clr_scr2

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     defk2(pc)       ;adress of the string
        move.w  #16,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     retour(pc)       ;adress of the string
        move.w  #24,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     defk1(pc)       ;adress of the string
        move.w  #8,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
        lea     10(a7),a7       ;restores the stack

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     vitesse(pc)       ;adress of the string
        move.w  #0,-(a7)        ;y coord
        move.w  #10,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack

        move.l  #0,d5
        bsr     affspeed
        bsr     affchoice

demarrage_opt:
        bsr     getkeystat
        lea     keystat(pc),a0
        btst.b  #0,1(a0)
        beq     demarrage_opt

keys_opt:
        move.w  #$F000,d2
l2pause_opt1:
        dbra.w  d2,l2pause_opt1
        move.w  #$F000,d2
l2pause_opt2:
        dbra.w  d2,l2pause_opt2

        bsr     getkeystat
        lea     keystat(pc),a2
        btst.b  #0,6(a2)
        beq     fin_opt
        btst.b  #0,1(a2)
        bne     suite_opt5
        cmp.b   #0,d5
        beq     fin_opt
        cmp.b   #3,d5
        beq     fin_opt
        cmp.b   #2,d5
        bne     suite_opt6
        bsr     ch_t_j2
        bra     options
suite_opt6:
        cmp.b   #1,d5
        bne     suite_opt5
        bsr     ch_t_j1
        bra     ch_t_j2
suite_opt5:
        cmp.b   #0,d5
        bne     suite_opt2
        btst.b  #1,(a2)
        bne     suite_opt1
        lea     speed(pc),a0
        move.b  (a0),d0
        cmp.b   #0,d0
        beq     suite_opt1
        sub.b   #1,d0
        move.b  d0,(a0)
        bsr     affspeed
suite_opt1:
        btst.b  #3,(a2)
        bne     suite_opt2
        lea     speed(pc),a0
        move.b  (a0),d0
        cmp.b   #9,d0
        beq     suite_opt2
        add.b   #1,d0
        move.b  d0,(a0)
        bsr     affspeed
suite_opt2:
        btst.b  #0,(a2)
        bne     suite_opt3
        cmp.b   #0,d5
        beq     suite_opt3
        bsr     affchoice
        sub.b   #1,d5
        bsr     affchoice
suite_opt3:
        btst.b  #2,(a2)
        bne     suite_opt4
        cmp.b   #3,d5
        beq     suite_opt4
        bsr     affchoice
        add.b   #1,d5
        bsr     affchoice
suite_opt4:
        bra     keys_opt

fin_opt:
        rts

ch_t_j2:
        move.w  #1,d0
        bsr     set_font

        move.b  #5,d7
        lea     kc2(pc),a2
        lea     touches(pc),a3
geto:
        move.w  #4,-(a7)        ;color #4 : black on whithe
        move.l  a3,-(a7)        ;adress of the string
        move.w  #40,-(a7)        ;y coord
        move.w  #62,-(a7)       ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack
        lea     7(a3),a3
pause_geto:
        move.w  #$F000,d0
p_g_j21:
        dbra.w  d0,p_g_j21
        move.w  #$F000,d0
p_g_j22:
        dbra.w  d0,p_g_j22
        bsr     getkeystat
        lea     keystat(pc),a1
        lea     keycode(pc),a0
        bsr     comp
        cmp.b   #0,d3
        bne     pause_geto
        lea     keystat(pc),a1
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        sub.b   #1,d7
        cmp.b   #0,d7
        bne     geto
        rts

ch_t_j1:
        move.w  #1,d0
        bsr     set_font

        move.b  #5,d7
        lea     kc1(pc),a2
        lea     touches(pc),a3
geto1:
        move.w  #4,-(a7)        ;color #4 : black on whithe
        move.l  a3,-(a7)        ;adress of the string
        move.w  #40,-(a7)        ;y coord
        move.w  #62,-(a7)       ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack
        lea     7(a3),a3
pause_geto1:
        move.w  #$F000,d0
p_g_j11:
        dbra.w  d0,p_g_j11
        move.w  #$F000,d0
p_g_j12:
        dbra.w  d0,p_g_j12
        bsr     getkeystat
        lea     keystat(pc),a1
        lea     keycode(pc),a0
        bsr     comp
        cmp.b   #0,d3
        bne     pause_geto1
        lea     keystat(pc),a1
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        move.b  (a1)+,(a2)+
        sub.b   #1,d7
        cmp.b   #0,d7
        bne     geto1
        rts

affchoice:
        lea     LCD_MEM,a0
        move.l  d5,d4
        lsl.l   #3,d4
        move.l  d4,d3
        lsl.l   #5,d4
        lsl.l   #1,d3
        sub.l   d3,d4
        adda.l  d4,a0
        lea     diamond(pc),a1
        move.w  #7,d6
loop_affch:
        move.b  (a1)+,d0
        eor.b   d0,(a0)
        lea     30(a0),a0
        dbra.w  d6,loop_affch
        rts

affspeed:
        lea     speed(pc),a0
        lea     char(pc),a1
        clr.b   (a1)
        move.b  (a0),(a1)
        add.b   #48,(a1)

        move.w  #4,-(a7)        ;color #4 : black on whithe
        pea     char(pc)       ;adress of the string
        move.w  #0,-(a7)        ;y coord
        move.w  #69,-(a7)        ;x coord
        jsr     doorsos::DrawStrXY      ;calls the ROM function which draws a string in current font
	lea	10(a7),a7	;restores the stack
        rts

;***********************************************************************************************
;* Compare (a0)+ et (a1)+ 7 fois, si oui alors #1 dans d3.b, sinon #0 dans d3.b et restaure a0 *
;***********************************************************************************************
comp:
        movem.l d0/a0,-(a7)
        move.w  #6,d0
        move.b  #1,d3
loop_comp1:
        cmp.b   (a0)+,(a1)+
        beq     diff1
        move.b  #0,d3
diff1:
        dbra.w  d0,loop_comp1
        movem.l (a7)+,d0/a0
        rts

comp2:
        movem.l d0-d2/a0,-(a7)
        move.w  #6,d0
        move.b  #1,d3
loop_comp2:
        cmp.b   #$FF,(a1)
        beq     diff2
        move.b  (a1),d1
        move.b  (a0),d2
        or.b    d2,d1
        not.b   d1
        cmp.b   #0,d1
        bne     diff2
        move.b  #0,d3
diff2:
        lea     1(a0),a0
        lea     1(a1),a1
        sub.w   #1,d0
        cmp.b   #255,d0
        bne     loop_comp2
        movem.l (a7)+,d0-d2/a0
        rts

DrawStrXY:
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7
        rts
;*******
; Generate a random value between 0 and d0.w-1, place it in d0.w
;*******


random:
  movem.l d6/a6,-(a7)
  lea rand_seed(pc),a6
  move.w  (a6),d6
  mulu.w  #31471,d6
  add.w   #6927,d6
  mulu.w  d6,d0
  move.w  d6,(a6)
  clr.w   d0
  swap    d0
  movem.l (a7)+,d6/a6
  rts

keycode dcb.b   7*7,$FF
keystat dcb.b   7*7,$FF

kc1:
        dcb.b    5*7,$FF
kc2:
        dcb.b   5*7,$FF

rand_seed       dc.w    542
just_b_p1       dc.w    0
just_b_p2       dc.w    0
bombe_p1        dc.w    0,0,0,0,0,0
bombe_p2        dc.w    0,0,0,0,0,0
btab_p1         dcb.w   6*6,0
btab_p2         dcb.w   6*6,0
speed           dc.b    7
force_p1        dc.w    0
force_p2        dc.w    0
nb_p1   dc.w    2
nb_p2   dc.w    2
pt_p1   dc.b    0
pt_p2   dc.b    0
exp:
        dc.w    8
        dc.w    1
        dc.b    %01100110
        dc.b    %11111111
        dc.b    %11111111
        dc.b    %01100110
        dc.b    %01100110
        dc.b    %11111111
        dc.b    %11111111
        dc.b    %01100110
bplus:
        dc.w    8
        dc.w    1
        dc.b    %00001000
        dc.b    %00010000
        dc.b    %00111000
        dc.b    %01000100
        dc.b    %01000100
        dc.b    %01000100
        dc.b    %00111000
        dc.b    %00000000
p2:        
        dc.w    8
        dc.w    1
        dc.b    %00111000
        dc.b    %00101000
        dc.b    %00010000
        dc.b    %01111100
        dc.b    %00010000
        dc.b    %00101000
        dc.b    %01101100
        dc.b    %00000000
p1:
        dc.w    8
        dc.w    1
        dc.b    %00111000
        dc.b    %00101000
        dc.b    %00010010
        dc.b    %01111100
        dc.b    %10010000
        dc.b    %00101000
        dc.b    %00101000
        dc.b    %00000000
pp:
        dc.w    8
        dc.w    1
        dc.b    %00001000
        dc.b    %00011000
        dc.b    %11101000
        dc.b    %01000100
        dc.b    %00101110
        dc.b    %00110000
        dc.b    %00100000
        dc.b    %00000000
blanc:
        dc.w    8
        dc.w    1
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
        dc.b    %00000000
brique:     
        dc.w    8
        dc.w    1
        dc.b    %10001000
        dc.b    %11111111
        dc.b    %00100010
        dc.b    %00100010
        dc.b    %00100010
        dc.b    %11111111
        dc.b    %10001000
        dc.b    %10001000
bombe:
        dc.w    8
        dc.w    1
        dc.b    %00111000
        dc.b    %01111100
        dc.b    %11011110
        dc.b    %11111110
        dc.b    %11111110
        dc.b    %01111100
        dc.b    %00111000
        dc.b    %00000000
mur:
        dc.w    8
        dc.w    1
        dc.b    %11111111
        dc.b    %10100101
        dc.b    %11011011
        dc.b    %10011001
        dc.b    %10011001
        dc.b    %11011011
        dc.b    %10100101
        dc.b    %11111111

diamond:
        dc.b    %00000000
        dc.b    %00001000
        dc.b    %00011100
        dc.b    %00111110
        dc.b    %00011100
        dc.b    %00001000
        dc.b    %00000000
        dc.b    %00000000

numbers:
        dc.b %01111100  
	dc.b %11000110
	dc.b %11000110
	dc.b %11010110
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

        dc.b %00011000  
	dc.b %00111000
	dc.b %01111000
	dc.b %00011000
	dc.b %00011000
	dc.b %00011000
	dc.b %01111110
	dc.b %00000000

        dc.b %01111100  
	dc.b %11000110
	dc.b %00000110
	dc.b %00111100
	dc.b %01100000
	dc.b %11000000
	dc.b %11111110
	dc.b %00000000

        dc.b %11111110  
	dc.b %00000110
	dc.b %00001100
	dc.b %00111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

        dc.b %00011100  
	dc.b %00111100
	dc.b %01101100
	dc.b %11001100
	dc.b %11111110
	dc.b %00001100
	dc.b %00001100
	dc.b %00000000

        dc.b %11111110  
	dc.b %11000000
	dc.b %11000000
	dc.b %11111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

        dc.b %00111100  
        dc.b %01100000
	dc.b %11000000
	dc.b %11111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

        dc.b %11111110  
	dc.b %00000110
	dc.b %00001100
	dc.b %00011000
	dc.b %00110000
	dc.b %01100000
	dc.b %11000000
	dc.b %00000000

        dc.b %01111100  
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

        dc.b %01111100  
	dc.b %11000110
	dc.b %11000110
	dc.b %01111110
	dc.b %00000110
	dc.b %00001100
	dc.b %01111000
	dc.b %00000000

        dc.b %00000000  
        dc.b %00111000
        dc.b %01111100
        dc.b %01111100
        dc.b %01111100
        dc.b %00111000
        dc.b %00000000
	dc.b %00000000

tab     dcb.b   209,0
xy_p1   dc.l    0,0
xy_p2   dc.l    0,0
grob:
        dc.b    %01010101
        dc.b    %10101010
        dc.b    %01010101
        dc.b    %11111111

choose  dc.b    0
dp1     dc.b    "Le joueur 1 est BOMBE!",0
dp2     dc.b    "Le joueur 2 est BOMBE!",0
pl1     dc.b    "Left Player",0
pl2     dc.b    "Right Player",0
touches dc.b    "Bombe ",0," Haut ",0," Bas  ",0,"Gauche",0,"Droite",0
misenp  dc.b    "par C. PASCAL",0
vitesse dc.b    "Vitesse : ",0
titre   dc.b    "BOMBERMAN",0
start   dc.b    "Jouer",0
defkey  dc.b    "Options",0
defk1   dc.b    "Changer touches joueur 1",0
defk2   dc.b    "Changer touches joueur 2",0
first1  dc.b    "Definition touches Joueur 1",0
first2  dc.b    "Definition touches Joueur 2",0
quit    dc.b    "Quitter",0
retour  dc.b    "Retour",0
char    dc.b    0,0
txt     dc.b    "Bienvenue sur BOMBERMAN,"
	 dc.b	  " un des jeux les plus connus au Monde. J'espere que ce jeu "
        dc.b    "va vous plaire"
        dc.b    ". J'espere aussi qu'il n'y a aucun grod BUG. S'il y en a, "
        dc.b    "contactez-moi par E-mail. "
        dc.b    "Je tiens a remmercier mes potes de Sainte-Croix (J."
        dc.b    "L.D. & Vincenzo, Julio & Thibo) qui me supportaient"
        dc.b    "tous les jours, ce de Pasteur, et "
        dc.b    "particulierement schnoufy, mon ancienne meilleur amie"
        dc.b    ". Amusez vous bien...                           ",0
_comment        dc.b    "BomberMan 2 Joueurs par Paxal",0
        
        end
